diff -uNrp linux-2.6.14.5/arch/s390/kernel/sys_s390.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/s390/kernel/sys_s390.c
--- linux-2.6.14.5/arch/s390/kernel/sys_s390.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/s390/kernel/sys_s390.c	2006-01-22 13:01:14.000000000 +0100
@@ -151,6 +151,8 @@ asmlinkage long sys_ipc(uint call, int f
         struct ipc_kludge tmp;
 	int ret;
 
+        ltt_ev_ipc(LTT_EV_IPC_CALL, call, first);
+
         switch (call) {
         case SEMOP:
 		return sys_semtimedop(first, (struct sembuf __user *)ptr,
diff -uNrp linux-2.6.14.5/arch/s390/kernel/traps.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/s390/kernel/traps.c
--- linux-2.6.14.5/arch/s390/kernel/traps.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/s390/kernel/traps.c	2006-01-22 13:01:14.000000000 +0100
@@ -5,6 +5,7 @@
  *    Copyright (C) 1999,2000 IBM Deutschland Entwicklung GmbH, IBM Corporation
  *    Author(s): Martin Schwidefsky (schwidefsky@de.ibm.com),
  *               Denis Joseph Barrow (djbarrow@de.ibm.com,barrow_dj@yahoo.com),
+ *  Portions added by T. Halloran: (C) Copyright 2002 IBM Poughkeepsie, IBM Corporation
  *
  *  Derived from "arch/i386/kernel/traps.c"
  *    Copyright (C) 1991, 1992 Linus Torvalds
@@ -30,6 +31,7 @@
 #include <linux/module.h>
 #include <linux/kallsyms.h>
 #include <linux/reboot.h>
+#include <linux/ltt-events.h>
 
 #include <asm/system.h>
 #include <asm/uaccess.h>
@@ -312,6 +314,9 @@ report_user_fault(long interruption_code
 static void inline do_trap(long interruption_code, int signr, char *str,
                            struct pt_regs *regs, siginfo_t *info)
 {
+         trapid_t ltt_interruption_code;
+         char * ic_ptr = (char *) &ltt_interruption_code;
+
 	/*
 	 * We got all needed information from the lowcore and can
 	 * now safely switch on interrupts.
@@ -319,6 +324,10 @@ static void inline do_trap(long interrup
         if (regs->psw.mask & PSW_MASK_PSTATE)
 		local_irq_enable();
 
+	memset(&ltt_interruption_code,0,sizeof(ltt_interruption_code));
+	memcpy(ic_ptr+4,&interruption_code,sizeof(interruption_code));
+	ltt_ev_trap_entry(ltt_interruption_code, (regs->psw.addr & PSW_ADDR_INSN));
+
         if (regs->psw.mask & PSW_MASK_PSTATE) {
                 struct task_struct *tsk = current;
 
@@ -333,6 +342,7 @@ static void inline do_trap(long interrup
                 else
                         die(str, regs, interruption_code);
         }
+	ltt_ev_trap_exit();
 }
 
 static inline void *get_check_address(struct pt_regs *regs)
@@ -429,6 +439,8 @@ asmlinkage void illegal_op(struct pt_reg
 	siginfo_t info;
         __u8 opcode[6];
 	__u16 *location;
+        trapid_t ltt_interruption_code;
+        char * ic_ptr = (char *) &ltt_interruption_code;
 	int signal = 0;
 
 	location = (__u16 *) get_check_address(regs);
@@ -491,6 +503,7 @@ asmlinkage void illegal_op(struct pt_reg
 		do_trap(interruption_code, signal,
 			"illegal operation", regs, &info);
 	}
+	ltt_ev_trap_exit();
 }
 
 
@@ -500,6 +513,8 @@ specification_exception(struct pt_regs *
 {
         __u8 opcode[6];
 	__u16 *location = NULL;
+        trapid_t ltt_interruption_code;
+        char * ic_ptr = (char *) &ltt_interruption_code;
 	int signal = 0;
 
 	location = (__u16 *) get_check_address(regs);
@@ -555,6 +570,7 @@ specification_exception(struct pt_regs *
 		do_trap(interruption_code, signal, 
 			"specification exception", regs, &info);
 	}
+	ltt_ev_trap_exit();
 }
 #else
 DO_ERROR_INFO(SIGILL, "specification exception", specification_exception,
@@ -564,6 +580,8 @@ DO_ERROR_INFO(SIGILL, "specification exc
 asmlinkage void data_exception(struct pt_regs * regs, long interruption_code)
 {
 	__u16 *location;
+        trapid_t ltt_interruption_code;
+        char * ic_ptr = (char *) &ltt_interruption_code;
 	int signal = 0;
 
 	location = (__u16 *) get_check_address(regs);
@@ -575,6 +593,10 @@ asmlinkage void data_exception(struct pt
 	if (regs->psw.mask & PSW_MASK_PSTATE)
 		local_irq_enable();
 
+	memset(&ltt_interruption_code,0,sizeof(ltt_interruption_code));
+	memcpy(ic_ptr+4,&interruption_code,sizeof(interruption_code));
+	ltt_ev_trap_entry(ltt_interruption_code, (regs->psw.addr & PSW_ADDR_INSN));
+
 	if (MACHINE_HAS_IEEE)
 		__asm__ volatile ("stfpc %0\n\t" 
 				  : "=m" (current->thread.fp_regs.fpc));
@@ -650,6 +672,7 @@ asmlinkage void data_exception(struct pt
 		do_trap(interruption_code, signal, 
 			"data exception", regs, &info);
 	}
+	ltt_ev_trap_exit();
 }
 
 asmlinkage void space_switch_exception(struct pt_regs * regs, long int_code)
diff -uNrp linux-2.6.14.5/arch/s390/mm/fault.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/s390/mm/fault.c
--- linux-2.6.14.5/arch/s390/mm/fault.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/s390/mm/fault.c	2006-01-22 13:01:14.000000000 +0100
@@ -5,6 +5,7 @@
  *    Copyright (C) 1999 IBM Deutschland Entwicklung GmbH, IBM Corporation
  *    Author(s): Hartmut Penner (hp@de.ibm.com)
  *               Ulrich Weigand (uweigand@de.ibm.com)
+ *  Portions added by T. Halloran: (C) Copyright 2002 IBM Poughkeepsie, IBM Corporation
  *
  *  Derived from "arch/i386/mm/fault.c"
  *    Copyright (C) 1995  Linus Torvalds
@@ -170,6 +171,8 @@ do_exception(struct pt_regs *regs, unsig
 	int user_address;
 	const struct exception_table_entry *fixup;
 	int si_code = SEGV_MAPERR;
+	trapid_t ltt_interruption_code;
+	char * ic_ptr = (char *) &ltt_interruption_code;
 
         tsk = current;
         mm = tsk->mm;
@@ -217,6 +220,9 @@ do_exception(struct pt_regs *regs, unsig
 	 */
 	local_irq_enable();
 
+        memset(&ltt_interruption_code,0,sizeof(ltt_interruption_code));
+        memcpy(ic_ptr+4,&error_code,sizeof(error_code));
+        ltt_ev_trap_entry(ltt_interruption_code,(regs->psw.addr & PSW_ADDR_INSN));
         down_read(&mm->mmap_sem);
 
         vma = find_vma(mm, address);
@@ -284,6 +290,7 @@ bad_area:
                 tsk->thread.prot_addr = address;
                 tsk->thread.trap_no = error_code;
 		do_sigsegv(regs, error_code, si_code, address);
+                ltt_ev_trap_exit();
                 return;
 	}
 
@@ -339,6 +346,8 @@ do_sigbus:
 	/* Kernel mode? Handle exceptions or die */
 	if (!(regs->psw.mask & PSW_MASK_PSTATE))
 		goto no_context;
+
+	ltt_ev_trap_exit();
 }
 
 void do_protection_exception(struct pt_regs *regs, unsigned long error_code)
diff -uNrp linux-2.6.14.5/arch/sh/kernel/irq.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/kernel/irq.c
--- linux-2.6.14.5/arch/sh/kernel/irq.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/kernel/irq.c	2006-01-22 13:01:14.000000000 +0100
@@ -32,6 +32,7 @@
 #include <linux/seq_file.h>
 #include <linux/kallsyms.h>
 #include <linux/bitops.h>
+#include <linux/ltt-events.h>
 
 #include <asm/system.h>
 #include <asm/io.h>
diff -uNrp linux-2.6.14.5/arch/sh/kernel/process.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/kernel/process.c
--- linux-2.6.14.5/arch/sh/kernel/process.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/kernel/process.c	2006-01-22 13:01:14.000000000 +0100
@@ -20,6 +20,7 @@
 #include <linux/ptrace.h>
 #include <linux/platform.h>
 #include <linux/kallsyms.h>
+#include <linux/ltt-events.h>
 
 #include <asm/io.h>
 #include <asm/uaccess.h>
diff -uNrp linux-2.6.14.5/arch/sh/kernel/sys_sh.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/kernel/sys_sh.c
--- linux-2.6.14.5/arch/sh/kernel/sys_sh.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/kernel/sys_sh.c	2006-01-22 13:01:14.000000000 +0100
@@ -21,6 +21,7 @@
 #include <linux/mman.h>
 #include <linux/file.h>
 #include <linux/utsname.h>
+#include <linux/ltt-events.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -174,6 +175,8 @@ asmlinkage int sys_ipc(uint call, int fi
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
+	ltt_ev_ipc(LTT_EV_IPC_CALL, call, first);
+
 	if (call <= SEMCTL)
 		switch (call) {
 		case SEMOP:
diff -uNrp linux-2.6.14.5/arch/sh/kernel/traps.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/kernel/traps.c
--- linux-2.6.14.5/arch/sh/kernel/traps.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/kernel/traps.c	2006-01-22 13:01:14.000000000 +0100
@@ -27,6 +27,7 @@
 #include <linux/spinlock.h>
 #include <linux/module.h>
 #include <linux/kallsyms.h>
+#include <linux/ltt-events.h>
 
 #include <asm/system.h>
 #include <asm/uaccess.h>
@@ -500,6 +501,8 @@ asmlinkage void do_address_error(struct 
 
 	asm volatile("stc       r2_bank,%0": "=r" (error_code));
 
+	ltt_ev_trap_entry(error_code >> 5, regs->pc);
+
 	oldfs = get_fs();
 
 	if (user_mode(regs)) {
@@ -523,8 +526,10 @@ asmlinkage void do_address_error(struct 
 		tmp = handle_unaligned_access(instruction, regs);
 		set_fs(oldfs);
 
-		if (tmp==0)
-			return; /* sorted */
+		if (tmp==0) {
+			ltt_ev_trap_exit();
+ 			return; /* sorted */
+		}
 
 	uspace_segv:
 		printk(KERN_NOTICE "Killing process \"%s\" due to unaligned access\n", current->comm);
@@ -545,6 +550,7 @@ asmlinkage void do_address_error(struct 
 		handle_unaligned_access(instruction, regs);
 		set_fs(oldfs);
 	}
+	ltt_ev_trap_exit();
 }
 
 #ifdef CONFIG_SH_DSP
@@ -704,6 +710,74 @@ void show_task(unsigned long *sp)
 {
 	show_stack(NULL, sp);
 }
+/* Trace related code */
+#if (CONFIG_LTT)
+asmlinkage void trace_real_syscall_entry(struct pt_regs *regs)
+{
+	int use_depth;
+	int use_bounds;
+	int depth = 0;
+	int seek_depth;
+	unsigned long lower_bound;
+	unsigned long upper_bound;
+	unsigned long addr;
+	unsigned long *stack;
+	ltt_syscall_entry trace_syscall_event;
+
+	/* Set the syscall ID */
+	trace_syscall_event.syscall_id = (uint8_t) regs->regs[REG_REG0 + 3];
+
+	/* Set the address in any case */
+	trace_syscall_event.address = regs->pc;
+
+	/* Are we in the kernel (This is a kernel thread)? */
+	if (!user_mode(regs))
+		/* Don't go digining anywhere */
+		goto trace_syscall_end;
+
+	/* Get the trace configuration */
+	if (ltt_get_trace_config(&use_depth, &use_bounds, &seek_depth,
+				(void *) &lower_bound, (void *) &upper_bound) < 0)
+		goto trace_syscall_end;
+
+	/* Do we have to search for an eip address range */
+	if ((use_depth == 1) || (use_bounds == 1)) {
+		/* Start at the top of the stack (bottom address since stacks grow downward) */
+		stack = (unsigned long *) regs->regs[REG_REG15];
+
+		/* Keep on going until we reach the end of the process' stack limit (wherever it may be) */
+		while (!get_user(addr, stack)) {
+			/* Does this LOOK LIKE an address in the program */
+			/* TODO: does this work with shared libraries?? - Greg Banks */
+			if ((addr > current->mm->start_code) && (addr < current->mm->end_code)) {
+				/* Does this address fit the description */
+				if (((use_depth == 1) && (depth == seek_depth))
+				    || ((use_bounds == 1) && (addr > lower_bound)
+					&& (addr < upper_bound))) {
+					/* Set the address */
+					trace_syscall_event.address = addr;
+
+					/* We're done */
+					goto trace_syscall_end;
+				} else
+					/* We're one depth more */
+					depth++;
+			}
+			/* Go on to the next address */
+			stack++;
+		}
+	}
+trace_syscall_end:
+	/* Trace the event */
+	ltt_log_event(LTT_EV_SYSCALL_ENTRY, &trace_syscall_event);
+}
+
+asmlinkage void trace_real_syscall_exit(void)
+{
+	ltt_log_event(LTT_EV_SYSCALL_EXIT, NULL);
+}
+
+#endif				/* (CONFIG_LTT) */
 
 void dump_stack(void)
 {
diff -uNrp linux-2.6.14.5/arch/sh/mm/fault.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/mm/fault.c
--- linux-2.6.14.5/arch/sh/mm/fault.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/arch/sh/mm/fault.c	2006-01-22 13:01:14.000000000 +0100
@@ -21,6 +21,7 @@
 #include <linux/smp_lock.h>
 #include <linux/interrupt.h>
 #include <linux/module.h>
+#include <linux/ltt-events.h>
 
 #include <asm/system.h>
 #include <asm/io.h>
@@ -53,6 +54,14 @@ asmlinkage void do_page_fault(struct pt_
 	tsk = current;
 	mm = tsk->mm;
 
+#if (CONFIG_LTT)
+	{
+		unsigned long trapnr;
+		asm volatile("stc       r2_bank,%0": "=r" (trapnr));
+		ltt_ev_trap_entry(trapnr >> 5, regs->pc);  /* trap 4,5 or 6 */
+	}
+#endif
+
 	/*
 	 * If we're in an interrupt or have no user
 	 * context, we must not take the fault..
@@ -106,6 +115,7 @@ survive:
 	}
 
 	up_read(&mm->mmap_sem);
+	ltt_ev_trap_exit();
 	return;
 
 /*
@@ -119,6 +129,7 @@ bad_area:
 		tsk->thread.address = address;
 		tsk->thread.error_code = writeaccess;
 		force_sig(SIGSEGV, tsk);
+		ltt_ev_trap_exit();
 		return;
 	}
 
@@ -185,6 +196,8 @@ do_sigbus:
 	/* Kernel mode? Handle exceptions or die */
 	if (!user_mode(regs))
 		goto no_context;
+
+	ltt_ev_trap_exit();
 }
 
 /*
diff -uNrp linux-2.6.14.5/fs/buffer.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/buffer.c
--- linux-2.6.14.5/fs/buffer.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/buffer.c	2006-01-22 13:01:14.000000000 +0100
@@ -18,6 +18,7 @@
  * async buffer flushing, 1999 Andrea Arcangeli <andrea@suse.de>
  */
 
+#include <linux/ltt/ltt-facility-fs.h>
 #include <linux/config.h>
 #include <linux/kernel.h>
 #include <linux/syscalls.h>
@@ -89,7 +90,9 @@ void fastcall unlock_buffer(struct buffe
  */
 void __wait_on_buffer(struct buffer_head * bh)
 {
+	trace_fs_buf_wait_start((void*)bh);
 	wait_on_bit(&bh->b_state, BH_Lock, sync_buffer, TASK_UNINTERRUPTIBLE);
+	trace_fs_buf_wait_end((void*)bh);
 }
 
 static void
diff -uNrp linux-2.6.14.5/fs/exec.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/exec.c
--- linux-2.6.14.5/fs/exec.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/exec.c	2006-01-22 13:01:14.000000000 +0100
@@ -22,6 +22,7 @@
  * formats. 
  */
 
+#include <linux/ltt/ltt-facility-fs.h>
 #include <linux/config.h>
 #include <linux/slab.h>
 #include <linux/file.h>
@@ -1147,6 +1148,7 @@ int do_execve(char * filename,
 	struct file *file;
 	int retval;
 	int i;
+	lttng_sequence_fs_exec_filename lttng_name;
 
 	retval = -ENOMEM;
 	bprm = kmalloc(sizeof(*bprm), GFP_KERNEL);
@@ -1159,6 +1161,10 @@ int do_execve(char * filename,
 	if (IS_ERR(file))
 		goto out_kfree;
 
+	lttng_name.len = file->f_dentry->d_name.len;
+	lttng_name.array = file->f_dentry->d_name.name;
+	trace_fs_exec(&lttng_name);
+
 	sched_exec();
 
 	bprm->p = PAGE_SIZE*MAX_ARG_PAGES-sizeof(void *);
diff -uNrp linux-2.6.14.5/fs/ioctl.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/ioctl.c
--- linux-2.6.14.5/fs/ioctl.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/ioctl.c	2006-01-22 13:01:14.000000000 +0100
@@ -4,6 +4,7 @@
  *  Copyright (C) 1991, 1992  Linus Torvalds
  */
 
+#include <linux/ltt/ltt-facility-fs.h>
 #include <linux/config.h>
 #include <linux/syscalls.h>
 #include <linux/mm.h>
@@ -60,7 +61,6 @@ static int file_ioctl(struct file *filp,
 				return -EPERM;
 			if ((error = get_user(block, p)) != 0)
 				return error;
-
 			lock_kernel();
 			res = mapping->a_ops->bmap(mapping, block);
 			unlock_kernel();
@@ -166,6 +166,8 @@ asmlinkage long sys_ioctl(unsigned int f
 	if (!filp)
 		goto out;
 
+	trace_fs_ioctl(fd, cmd, arg);
+
 	error = security_file_ioctl(filp, cmd, arg);
 	if (error)
 		goto out_fput;
diff -uNrp linux-2.6.14.5/fs/open.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/open.c
--- linux-2.6.14.5/fs/open.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/open.c	2006-01-22 13:01:14.000000000 +0100
@@ -4,6 +4,7 @@
  *  Copyright (C) 1991, 1992  Linus Torvalds
  */
 
+#include <linux/ltt/ltt-facility-fs.h>
 #include <linux/string.h>
 #include <linux/mm.h>
 #include <linux/utime.h>
@@ -19,6 +20,7 @@
 #include <linux/security.h>
 #include <linux/mount.h>
 #include <linux/vfs.h>
+
 #include <asm/uaccess.h>
 #include <linux/fs.h>
 #include <linux/personality.h>
@@ -957,6 +959,8 @@ long do_sys_open(const char __user *file
 	char *tmp = getname(filename);
 	int fd = PTR_ERR(tmp);
 
+	lttng_sequence_fs_open_filename lttng_name;
+
 	if (!IS_ERR(tmp)) {
 		fd = get_unused_fd();
 		if (fd >= 0) {
@@ -966,6 +970,10 @@ long do_sys_open(const char __user *file
 				fd = PTR_ERR(f);
 			} else {
 				fsnotify_open(f->f_dentry);
+				lttng_name.len = f->f_dentry->d_name.len;
+				lttng_name.array = f->f_dentry->d_name.name;
+				trace_fs_open(&lttng_name,
+						fd);
 				fd_install(fd, f);
 			}
 		}
@@ -1038,6 +1046,7 @@ asmlinkage long sys_close(unsigned int f
 	filp = fdt->fd[fd];
 	if (!filp)
 		goto out_unlock;
+	trace_fs_close(fd);
 	rcu_assign_pointer(fdt->fd[fd], NULL);
 	FD_CLR(fd, fdt->close_on_exec);
 	__put_unused_fd(files, fd);
diff -uNrp linux-2.6.14.5/fs/read_write.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/read_write.c
--- linux-2.6.14.5/fs/read_write.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/read_write.c	2006-01-22 13:01:14.000000000 +0100
@@ -4,6 +4,7 @@
  *  Copyright (C) 1991, 1992  Linus Torvalds
  */
 
+#include <linux/ltt/ltt-facility-fs.h>
 #include <linux/slab.h> 
 #include <linux/stat.h>
 #include <linux/fcntl.h>
@@ -142,6 +143,9 @@ asmlinkage off_t sys_lseek(unsigned int 
 		if (res != (loff_t)retval)
 			retval = -EOVERFLOW;	/* LFS: should only happen on 32 bit platforms */
 	}
+
+	trace_fs_seek(fd, offset, origin);
+
 	fput_light(file, fput_needed);
 bad:
 	return retval;
@@ -169,6 +173,8 @@ asmlinkage long sys_llseek(unsigned int 
 	offset = vfs_llseek(file, ((loff_t) offset_high << 32) | offset_low,
 			origin);
 
+	trace_fs_seek(fd, offset, origin);
+
 	retval = (int)offset;
 	if (offset >= 0) {
 		retval = -EFAULT;
@@ -334,6 +340,7 @@ asmlinkage ssize_t sys_read(unsigned int
 	file = fget_light(fd, &fput_needed);
 	if (file) {
 		loff_t pos = file_pos_read(file);
+		trace_fs_read(fd, count);
 		ret = vfs_read(file, buf, count, &pos);
 		file_pos_write(file, pos);
 		fput_light(file, fput_needed);
@@ -352,6 +359,7 @@ asmlinkage ssize_t sys_write(unsigned in
 	file = fget_light(fd, &fput_needed);
 	if (file) {
 		loff_t pos = file_pos_read(file);
+		trace_fs_write(fd, count);
 		ret = vfs_write(file, buf, count, &pos);
 		file_pos_write(file, pos);
 		fput_light(file, fput_needed);
@@ -373,8 +381,11 @@ asmlinkage ssize_t sys_pread64(unsigned 
 	file = fget_light(fd, &fput_needed);
 	if (file) {
 		ret = -ESPIPE;
-		if (file->f_mode & FMODE_PREAD)
+		if (file->f_mode & FMODE_PREAD) {
+			trace_fs_read(fd, count);
 			ret = vfs_read(file, buf, count, &pos);
+		}
+
 		fput_light(file, fput_needed);
 	}
 
@@ -394,8 +405,10 @@ asmlinkage ssize_t sys_pwrite64(unsigned
 	file = fget_light(fd, &fput_needed);
 	if (file) {
 		ret = -ESPIPE;
-		if (file->f_mode & FMODE_PWRITE)  
+ 		if (file->f_mode & FMODE_PWRITE) {
+			trace_fs_write(fd, count);
 			ret = vfs_write(file, buf, count, &pos);
+		}
 		fput_light(file, fput_needed);
 	}
 
@@ -590,6 +603,7 @@ sys_readv(unsigned long fd, const struct
 	file = fget_light(fd, &fput_needed);
 	if (file) {
 		loff_t pos = file_pos_read(file);
+		trace_fs_read(fd, vlen);
 		ret = vfs_readv(file, vec, vlen, &pos);
 		file_pos_write(file, pos);
 		fput_light(file, fput_needed);
@@ -611,6 +625,7 @@ sys_writev(unsigned long fd, const struc
 	file = fget_light(fd, &fput_needed);
 	if (file) {
 		loff_t pos = file_pos_read(file);
+		trace_fs_write(fd, vlen);
 		ret = vfs_writev(file, vec, vlen, &pos);
 		file_pos_write(file, pos);
 		fput_light(file, fput_needed);
diff -uNrp linux-2.6.14.5/fs/relayfs/inode.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/relayfs/inode.c
--- linux-2.6.14.5/fs/relayfs/inode.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/fs/relayfs/inode.c	2006-01-22 13:01:14.000000000 +0100
@@ -61,7 +61,7 @@ static struct inode *relayfs_get_inode(s
 	inode->i_atime = inode->i_mtime = inode->i_ctime = CURRENT_TIME;
 	switch (mode & S_IFMT) {
 	case S_IFREG:
-		inode->i_fop = &relayfs_file_operations;
+		inode->i_fop = &chan->fops;
 		RELAYFS_I(inode)->buf = buf;
 		break;
 	case S_IFDIR:
@@ -206,10 +206,10 @@ int relayfs_remove(struct dentry *dentry
 	parent = dget(parent);
 	down(&parent->d_inode->i_sem);
 	if (dentry->d_inode) {
-		if (S_ISDIR(dentry->d_inode->i_mode))
-			error = simple_rmdir(parent->d_inode, dentry);
-		else
-			error = simple_unlink(parent->d_inode, dentry);
+		//if (S_ISDIR(dentry->d_inode->i_mode))
+		//	error = simple_rmdir(parent->d_inode, dentry);
+		//else
+		error = simple_unlink(parent->d_inode, dentry);
 		if (!error)
 			d_delete(dentry);
 	}
@@ -232,6 +232,9 @@ int relayfs_remove(struct dentry *dentry
  */
 int relayfs_remove_dir(struct dentry *dentry)
 {
+	if (!dentry)
+		return -EINVAL;
+
 	return relayfs_remove(dentry);
 }
 
@@ -245,6 +248,12 @@ int relayfs_remove_dir(struct dentry *de
 static int relayfs_open(struct inode *inode, struct file *filp)
 {
 	struct rchan_buf *buf = RELAYFS_I(inode)->buf;
+
+	if(!atomic_dec_and_test(&buf->open_count)) {
+		atomic_inc(&buf->open_count);
+		return -EACCES;
+	}
+	
 	kref_get(&buf->kref);
 
 	return 0;
@@ -288,6 +297,7 @@ static unsigned int relayfs_poll(struct 
 	return mask;
 }
 
+
 /**
  *	relayfs_release - release file op for relayfs files
  *	@inode: the inode
@@ -299,6 +309,9 @@ static unsigned int relayfs_poll(struct 
 static int relayfs_release(struct inode *inode, struct file *filp)
 {
 	struct rchan_buf *buf = RELAYFS_I(inode)->buf;
+
+	atomic_inc(&buf->open_count);
+	
 	kref_put(&buf->kref, relay_remove_buf);
 
 	return 0;
@@ -444,6 +457,13 @@ static size_t relayfs_read_end_pos(struc
 	return end_pos;
 }
 
+int relayfs_ioctl(struct inode *inode, struct file *filp,
+		unsigned int cmd, unsigned long arg)
+{
+	printk(KERN_WARNING "Relayfs ioctl unimplemented\n");
+	return -EPERM;
+}
+
 /**
  *	relayfs_read - read file op for relayfs files
  *	@filp: the file
@@ -518,14 +538,34 @@ static void init_once(void *p, kmem_cach
 		inode_init_once(&i->vfs_inode);
 }
 
-struct file_operations relayfs_file_operations = {
-	.open		= relayfs_open,
-	.poll		= relayfs_poll,
-	.mmap		= relayfs_mmap,
-	.read		= relayfs_read,
-	.llseek		= no_llseek,
-	.release	= relayfs_release,
-};
+void setup_fileops(struct rchan *chan,
+				   struct file_operations *fops)
+{
+	memset(&chan->fops, 0, sizeof(chan->fops));
+	
+	chan->fops.open = fops->open;
+	chan->fops.poll = fops->poll;
+	chan->fops.mmap = fops->mmap;
+	chan->fops.release = fops->release;
+	chan->fops.ioctl = fops->ioctl;
+	chan->fops.llseek = fops->llseek;
+	chan->fops.read = fops->read;
+	
+	if (!chan->fops.open)
+		chan->fops.open = relayfs_open;
+	if (!chan->fops.poll)
+		chan->fops.poll = relayfs_poll;
+	if (!chan->fops.mmap)
+		chan->fops.mmap = relayfs_mmap;
+	if (!chan->fops.read)
+		chan->fops.read = relayfs_read;
+	if (!chan->fops.llseek)
+		chan->fops.llseek = no_llseek;
+	if (!chan->fops.release)
+		chan->fops.release = relayfs_release;
+	if (!chan->fops.ioctl)
+		chan->fops.ioctl = relayfs_ioctl;
+}
 
 static struct super_operations relayfs_ops = {
 	.statfs		= simple_statfs,
@@ -573,10 +613,16 @@ static struct file_system_type relayfs_f
 	.kill_sb	= kill_litter_super,
 };
 
+#ifdef CONFIG_IPIPE
+extern unsigned relay_wakeup_virq;
+void relay_wakeup_trampoline(unsigned virq);
+#endif /* CONFIG_IPIPE */
+
 static int __init init_relayfs_fs(void)
 {
 	int err;
 
+	printk(KERN_DEBUG "relayfs init\n");
 	relayfs_inode_cachep = kmem_cache_create("relayfs_inode_cache",
 				sizeof(struct relayfs_inode_info), 0,
 				0, init_once, NULL);
@@ -587,19 +633,38 @@ static int __init init_relayfs_fs(void)
 	if (err)
 		kmem_cache_destroy(relayfs_inode_cachep);
 
+#ifdef CONFIG_IPIPE
+	relay_wakeup_virq = ipipe_alloc_virq();
+
+	if (!relay_wakeup_virq) {
+	    printk(KERN_ERR "relayfs: no virtual interrupt available.\n");
+	    err = -EBUSY;
+	}
+	else
+	  err = ipipe_virtualize_irq(ipipe_root_domain,
+				     relay_wakeup_virq,
+				     &relay_wakeup_trampoline,
+				     NULL,
+				     IPIPE_HANDLE_MASK);
+#endif /* CONFIG_IPIPE */
+
 	return err;
 }
 
+
 static void __exit exit_relayfs_fs(void)
 {
+#ifdef CONFIG_IPIPE
+  ipipe_virtualize_irq(ipipe_root_domain,relay_wakeup_virq,NULL,NULL,0);
+  ipipe_free_virq(relay_wakeup_virq);
+#endif /* CONFIG_IPIPE */
 	unregister_filesystem(&relayfs_fs_type);
 	kmem_cache_destroy(relayfs_inode_cachep);
 }
 
-module_init(init_relayfs_fs)
+fs_initcall(init_relayfs_fs);
 module_exit(exit_relayfs_fs)
 
-EXPORT_SYMBOL_GPL(relayfs_file_operations);
 EXPORT_SYMBOL_GPL(relayfs_create_dir);
 EXPORT_SYMBOL_GPL(relayfs_remove_dir);
 
